﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Threading;

namespace Reaktionstester
{
   public partial class Form1 : Form
   {
      private int zaehler = 0;
      private const int LEVELS = 9;
      private Label[] anzeigen;
      private long startzeit;

      public Form1()
      {
         InitializeComponent();

         anzeigen = new Label[LEVELS];
         anzeigen[0] = lb_Level_1;
         anzeigen[1] = lb_Level_2;
         anzeigen[2] = lb_Level_3;
         anzeigen[3] = lb_Level_4;
         anzeigen[4] = lb_Level_5;
         anzeigen[5] = lb_Level_6;
         anzeigen[6] = lb_Level_7;
         anzeigen[7] = lb_Level_8;
         anzeigen[8] = lb_Level_9;
      }

   private void btn_Ausfuehren_Click(object sender, EventArgs e)
   {
      if (btn_Ausfuehren.Text == "Start")
      {
         // Schaltfläche "umdefinieren"
         btn_Ausfuehren.Text = "Stop";

         // eine unbestimmte Zeit zwischen 1 und 6 Sekunden warten
         Random gen = new Random();
         Thread.Sleep(gen.Next(1,7) * 1000);

         // Startzeit abspeichern
         startzeit = DateTime.Now.Ticks;

         // Zeitgeber starten, der die Levels einfärbt
         timer1.Start();

         // erstes Level einfärben
         anzeigen[zaehler].BackColor = Color.Black;
         ++zaehler;
      }
      else
      {
         // Stopzeit speichern
         long endzeit = DateTime.Now.Ticks;

         // Zeitgeber anhalten
         timer1.Stop();

         // Reaktionszeit berechnen und anzeigen
         long reaktionszeit = (endzeit-startzeit)/10000;
         MessageBox.Show(this, reaktionszeit.ToString(), 
                         "Ihre Reaktionszeit:");

         // Programm zurücksetzen
         zaehler = 0;
         foreach (Label lb in anzeigen)
            lb.BackColor = Color.White;

         // Schaltfläche "umdefinieren" und zaehler zurücksetzen
         btn_Ausfuehren.Text = "Start";
      }
   }

      private void timer1_Tick(object sender, EventArgs e)
      {
         anzeigen[zaehler].BackColor = Color.Black;

         ++zaehler;

         // Timer anhalten, wenn Zähler größer als Anzahl Label-Komponenten 
         if (zaehler >= LEVELS)
            timer1.Stop();
      }
   }
}
