using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.IO;
using System.Windows.Forms;

namespace Texteditor
{
    public partial class Form1 : Form
    {
        string dateiname = "unbekannt.txt";

        public Form1()
        {
            InitializeComponent();
            this.Text = "Texteditor - " + dateiname;
        }

        private void neuToolStripMenuItem_Click(object sender, EventArgs e)
        {
            textBox1.Clear();
            dateiname = "unbekannt.txt";
            this.Text = "Texteditor - " + dateiname;
        }

        private void ffnenToolStripMenuItem_Click(object sender, EventArgs e)
        {
            OpenFileDialog openFileDialog1 = new OpenFileDialog();

            // Startverzeichnis vorgeben, danach immer das zuletzt
            // angesteuerte Verzeichnis verwenden (nicht die Vorgabe
            // wiederherstellen
            openFileDialog1.InitialDirectory = ".";
            openFileDialog1.RestoreDirectory = false;

            // Filter fr Dateien mit den Extensionen .cs und .txt
            openFileDialog1.Filter = "CS-Dateien (*.cs)|*.cs|Textdateien (*.txt)|*.txt";

            // ersten Filter als Vorgabe auswhlen
            openFileDialog1.FilterIndex = 1;

            // es kann nur eine Datei ausgewhlt werden
            openFileDialog1.Multiselect = false;

            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
              Open(openFileDialog1.FileName);
            }
        }

        // ffnet die Datei und ldt ihren Inhalt
        private void Open(string dateiname)
        {
            try
            {
                StreamReader sr = new StreamReader(dateiname);
                textBox1.Text = sr.ReadToEnd();

                this.Text = "Texteditor - " + dateiname;
                sr.Close();
            }
            catch (IOException)
            {
                MessageBox.Show("Datei konnte nicht geffnet werden.", "Fehler");
            }
        }

        private void speichernToolStripMenuItem_Click(object sender, EventArgs e)
        {
            try
            {
                StreamWriter sw = new StreamWriter(dateiname);

                sw.Write(textBox1.Text);
                sw.Close();
            }
            catch (IOException)
            {
                MessageBox.Show("Datei konnte nicht gespeichert werden.", "Fehler");
            }

        }
        private void beendenToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void ausschneidenToolStripMenuItem_Click(object sender, EventArgs e)
        {
            textBox1.Cut();
        }

        private void kopierenToolStripMenuItem_Click(object sender, EventArgs e)
        {
            textBox1.Copy();
        }

        private void einfgenToolStripMenuItem_Click(object sender, EventArgs e)
        {
            textBox1.Paste();
        }


    }
}