using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Bildbetrachter
{
    public partial class Form1 : Form
    {
        Bitmap bild = null;

        public Form1()
        {
            InitializeComponent();
        }

        private void beendenToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void ffnenToolStripMenuItem_Click(object sender, EventArgs e)
        {
            OpenFileDialog openFileDialog1 = new OpenFileDialog();

            // Startverzeichnis vorgeben, aber nicht speichern
            // bei nachfolgenden Aufrufen soll das jeweils zuletzt 
            // gewhlte Verzeichnis angeboten werden
            openFileDialog1.InitialDirectory = ".";
            openFileDialog1.RestoreDirectory = false;
            
            // Filter fr Dateien mit den Extensionen .jpg, .tif und .bmp
            openFileDialog1.Filter 
                   = "Bilddateien (*.jpg;*.tif;*.bmp)|*.jpg;*.tif;*.bmp";
            
            // ersten Filter als Vorgabe auswhlen
            openFileDialog1.FilterIndex = 1;
            
            // es kann nur eine Datei ausgewhlt werden
            openFileDialog1.Multiselect = false;
            
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                try
                {
                    // Bild laden
                    bild = new Bitmap(openFileDialog1.FileName);

                    // Gre des Clientbereichs an Bildgre anpassen
                    this.ClientSize = new Size(bild.Width, bild.Height);

                    // Fenster mit Bild neu zeichnen
                    Refresh();
                }
                catch (Exception)
                {
                    MessageBox.Show("Bild konnte nicht geladen werden.", "Fehler");
                }
            }
        }
        
        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            if (bild != null)
                e.Graphics.DrawImage(bild, 0, 0, this.ClientRectangle.Width, this.ClientRectangle.Height);
        }
    }
}