using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Funktionenplotter
{
    public partial class Form1 : Form
    {
        int aktAuswahl = 0;

        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            aktAuswahl = 1;
            panel1.Refresh();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            aktAuswahl = 2;
            panel1.Refresh();
        }

        private void panel1_Paint(object sender, PaintEventArgs e)
        {
            Graphics g = e.Graphics;
            Pen stiftKOS = new Pen(Color.Red);
            Brush pinselKOS = new SolidBrush(Color.White);
            Brush pinselKurve = new SolidBrush(Color.Yellow);

            // Ursprung umsetzen
            g.TranslateTransform(panel1.Width / 2, panel1.Height / 2);

            // Koordinatenachsen einzeichnen
            g.DrawLine(stiftKOS, 0, -150, 0, 150);
            g.DrawLine(stiftKOS, -150, 0, 150, 0);
            g.DrawString("-3", this.Font, pinselKOS, -150, 12);
            g.DrawString("-3", this.Font, pinselKOS, 4, 135);
            g.DrawString("+3", this.Font, pinselKOS, 135, 12);
            g.DrawString("+3", this.Font, pinselKOS, 4, -145);

            // Ist keine Funktion ausgewhlt, nichts tun
            if (this.aktAuswahl == 0)
                return;

            // hier wird die gewnschte Funktion gezeichnet           double x, y;
            double x, y;
            int xpos, ypos;

            for (x = -3.0; x <= 3; x += 0.005)
            {
                if (this.aktAuswahl == 1)
                    y = Math.Pow(x, 3);
                else
                    y = Math.Tan(x);

                xpos = (int)(x * 50);
                ypos = (int)(-y * 50);
                g.FillEllipse(pinselKurve, xpos, ypos, 2, 2);  
            }
        }
    }
}