using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Data;
using System.Data.OleDb;    


namespace AccessDatenbankEditor
{
    public partial class Form1 : Form
    {
        const string verbindungsstr =  "Provider=Microsoft.Jet.OLEDB.4.0;"
                                      +"Data Source=C:\\Beispiele\\Kap13\\Laender.mdb";

        OleDbDataAdapter dbAdapter;
        DataSet dataSet1;
        BindingSource bindingSource1;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            try
            {
                // 1. Adapter erzeugen und 
                //    Verbindung mit Datenbank aufnehmen
                string abfrageString = "SELECT * FROM bndlaender";
                OleDbConnection verbindung = 
                                new OleDbConnection(verbindungsstr);
                dbAdapter = new OleDbDataAdapter(abfrageString, 
                                                 verbindung);
                
                // 2. DataSet erzeugen, Tabellenstruktur vorgeben 
                // und ber Adapter mit Daten fllen
                dataSet1 = new DataSet();
                dataSet1.Tables.Add("bndlaender");
                dbAdapter.Fill(dataSet1, "bndlaender");
                
                // 3. BindingSource erzeugen und 
                //    mit DataSet als Datenquelle verknpfen
                bindingSource1 = new BindingSource();
                bindingSource1.DataSource = dataSet1;
                bindingSource1.DataMember = "bndlaender";

                // 4. Steuerelemente ber BindingSource mit 
                //    Feldern der Datenbanktabelle verknpfen
                bindingNavigator1.BindingSource = bindingSource1;
                tbRang.DataBindings.Add(new Binding("Text", 
                                                    bindingSource1, 
                                                    "Rang"));
                tbBundesland.DataBindings.Add(new Binding("Text", 
                                                    bindingSource1, 
                                                    "Bundesland"));
                tbEinwohner.DataBindings.Add(new Binding("Text", 
                                                    bindingSource1, 
                                                    "Einwohner"));
                
                // 5. Befehle fr BindingNavigator automatisch 
                //    aus SELECT-Befehl generieren lassen
                OleDbCommandBuilder commandBuilder = 
                                 new OleDbCommandBuilder(dbAdapter);               
            }
            catch (OleDbException ex)
            {
                MessageBox.Show(ex.Message, "Datenbankfehler");
            }
            
        }

        private void bindingNavigatorSaveItem_Click(object sender, EventArgs e)
        {
            // 6. nderungen in DataSet in Datenbank schreiben
            bindingSource1.EndEdit();
            dbAdapter.Update(dataSet1.Tables["bndlaender"]);
        }
    }
}