using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Data.OleDb;

namespace AccessDatenbankbetrachter
{
    public partial class Form1 : Form
    {
        //const string verbindungsstr = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\\Beispiele\\Kap13\\Laender.mdb";
        const string verbindungsstr = "Provider=Microsoft.ACE.OLEDB.12.0;Data Source=C:\\Beispiele\\Kap13\\Laender.accdb";
        OleDbConnection verbindung = null;
        OleDbCommand befehl = null;
        OleDbDataReader leser = null;

        int[] dbRang;
        string[] dbBundesland;
        float[] dbEinwohner;
        int aktDatensatz = -1;


        public Form1()
        {
            InitializeComponent();

            dbRang = new int[16];
            dbBundesland = new string[16];
            dbEinwohner = new float[16];

            try
            {
                // Verbindung herstellen
                verbindung = new OleDbConnection(verbindungsstr);
                verbindung.Open();

                // Daten aus Datenbank abfragen 
                befehl = verbindung.CreateCommand();
                befehl.CommandText = "SELECT * FROM bndlaender";
                leser = befehl.ExecuteReader();

                // Daten in Arrays kopieren

                aktDatensatz = -1;
                while (leser.Read())
                {
                    aktDatensatz++;
                    dbRang[aktDatensatz] = leser.GetInt32(0);
                    dbBundesland[aktDatensatz] = leser.GetString(1);
                    dbEinwohner[aktDatensatz] = leser.GetFloat(2);
                }

                // Daten des ersten Datensatzes in Label ausgeben
                aktDatensatz = 0;
                label4.Text = dbRang[0].ToString();
                label5.Text = dbBundesland[0];
                label6.Text = dbEinwohner[0].ToString();
            }
            catch (OleDbException e)
            {
                MessageBox.Show(e.Message, "Datenbankfehler");
            }
            catch (Exception e)
            {
                MessageBox.Show(e.Message, "Datenbankfehler");
            }
            finally
            {
                if (leser != null)
                    leser.Close();
                if (verbindung != null)
                    verbindung.Close();
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            // Daten des vorigen aktDatensatzes in Label ausgeben
            if (aktDatensatz > 0)
                aktDatensatz--;
            label4.Text = dbRang[aktDatensatz].ToString();
            label5.Text = dbBundesland[aktDatensatz];
            label6.Text = dbEinwohner[aktDatensatz].ToString();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            // Daten des nchsten aktDatensatzes in Label ausgeben
            if (aktDatensatz < 15)
                aktDatensatz++;
            label4.Text = dbRang[aktDatensatz].ToString();
            label5.Text = dbBundesland[aktDatensatz];
            label6.Text = dbEinwohner[aktDatensatz].ToString();
        }
    }
}