using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.IO;
using System.Linq;

namespace U_Fotoanzeige_mitDrehenundGraustufen
{
   public partial class Form1 : Form
   {
      List<String> bilddateien;
      int index;

      public Form1()
      {
         InitializeComponent();
         bilddateien = new List<string>();
         index = 0;
      }



      //private void button1_Click(object sender, EventArgs e)
      //{
      //    int width = 0;
      //    int height = 0;
      //    int X = 0;
      //    int Y = 0;

      //    // Make a Bitmap representing the input background Image
      //    Bitmap img_bitmap_In = new Bitmap(pictureBox1.BackgroundImage);
      //    width = img_bitmap_In.Width;
      //    height = img_bitmap_In.Height;

      //    // Make the output bitmap.
      //    Bitmap img_bitmap_Out = new Bitmap(height, width);

      //    // Copy the pixel values.
      //    for (X = 0; X <= width - 1; X++)
      //    {
      //        for (Y = 0; Y <= height - 1; Y++)
      //        {
      //            img_bitmap_Out.SetPixel(height - Y - 1, X, img_bitmap_In.GetPixel(X, Y));
      //        }
      //    }

      //    // Display the result.
      //    pictureBox1.BackgroundImage = img_bitmap_Out;

      //}


      //public static Bitmap RotateImg(Bitmap bmp, float angle)
      //{

      //    int w = bmp.Width;

      //    int h = bmp.Height;

      //    Bitmap tempImg = new Bitmap(w, h);

      //    Graphics g = Graphics.FromImage(tempImg);

      //    g.DrawImageUnscaled(bmp, 1, 1);

      //    g.Dispose();

      //    GraphicsPath path = new GraphicsPath();

      //    path.AddRectangle(new RectangleF(0f, 0f, w, h));

      //    Matrix mtrx = new Matrix();

      //    mtrx.Rotate(angle);

      //    RectangleF rct = path.GetBounds(mtrx);

      //    Bitmap newImg = new Bitmap(Convert.ToInt32(rct.Width), Convert.ToInt32(rct.Height));

      //    g = Graphics.FromImage(newImg);

      //    g.TranslateTransform(-rct.X, -rct.Y);

      //    g.RotateTransform(angle);

      //    g.InterpolationMode = InterpolationMode.HighQualityBilinear;

      //    g.DrawImageUnscaled(tempImg, 0, 0);

      //    g.Dispose();

      //    tempImg.Dispose();

      //    return newImg;

      //}


      private void Form1_Load(object sender, EventArgs e)
      {
         // Die Namen der JPG-Dateien im Eigene Bilder-Order einlesen und in 
         // bilddateien speichern
         String bilderOrdner = Environment.GetFolderPath(Environment.SpecialFolder.MyPictures);
         bilddateien = Directory.EnumerateFiles(bilderOrdner, "*.jpg", SearchOption.AllDirectories).ToList();

         // Das erste Bild anzeigen
         if (bilddateien.Count > 0)
         {
            pbBild.Image = new Bitmap(bilddateien[index]);
         }
      }

      private void btnWeiter_Click(object sender, EventArgs e)
      {
         ++index;

         if (index >= bilddateien.Count)
         {
            index = 0;
         }

         if (index < bilddateien.Count)
         {
            pbBild.Image.Dispose();
            pbBild.Image = new Bitmap(bilddateien[index]);
         }

      }

      private void btn_Zurueck_Click(object sender, EventArgs e)
      {
         --index;

         if (index < 0)
         {
            index = bilddateien.Count - 1;
         }

         if (index < bilddateien.Count)
         {
            pbBild.Image.Dispose();
            pbBild.Image = new Bitmap(bilddateien[index]);
         }

      }

      private void btn_Rotate_Click(object sender, EventArgs e)
      {
         if (index >= 0 && index < bilddateien.Count)
         {
            Image bild = new Bitmap(bilddateien[index]);

            if (bild == null)
               return;

            // Bild rotieren
            bild.RotateFlip(RotateFlipType.Rotate90FlipNone);

            // Speichern (Leider kann man nicht in Bilddateien speichern, die in eine 
            //            Image-Komponente geladen wurden. Daher muss eine Kopie erstellt,
            //            die Image-Bilder freigegeben, dann gespeichert und anschlieend die
            //            Kopie in das Image geladen werden.)
            Bitmap copy = new Bitmap(bild);
            bild.Dispose();
            pbBild.Image.Dispose();
            copy.Save(bilddateien[index]);

            pbBild.Image = copy;
         }
      }

      private void btn_Graustufen_Click(object sender, EventArgs e)
      {
         // Die Umwandlung in Graustufen nach dem hier verwendeten Algorithmus kann fr 
         // grere Bilder etwas lnger dauern. Aus diesem Grund wird der Wartecursor angezeigt 
         // und die Arbeit mithilfe einer BackgroundWorker-Instanz erledigt.
         this.UseWaitCursor = true;

         // backgroundWorker1 ist eine Instanz der Komponente BackgroundWorker.
         // Im Eigenschaftenfenster wurden die Ereignisse DoWork und RunWorkerCompleted mit
         // Behandlungsmethoden verbunden.
         // Das DoWork-Ereignis tritt ein, wenn wir RunWorkerAsync() aufrufen.
         backgroundWorker1.RunWorkerAsync();
      }

      // Hier steht der Code, den der BackgroundWorker im HIntergrund ausfhren soll
      // In unserem Fall ist dies die Berechnung des Graustufenbildes
      private void backgroundWorker1_DoWork(object sender, DoWorkEventArgs e)
      {
         if (index >= 0 && index < bilddateien.Count)
         {
            Image bild = new Bitmap(bilddateien[index]);

            if (bild != null && bild is Bitmap)
            {
               Bitmap bitmap = (Bitmap)bild;
               Color c;
               int grauwert;

               if (bitmap == null)
                  return;

               // in Graustufen umrechnen
               for (int x = 0; x < bild.Width; ++x)
               {
                  for (int y = 0; y < bild.Height; ++y)
                  {
                     c = bitmap.GetPixel(x, y);

                     // Berechne einen gemeinsamen Wert fr den Rot-, Grn- und Blau-Anteil
                     grauwert = (30 * c.R + 59 * c.G + 11 * c.B) / 100;

                     // Grau entsteht, wenn R, G und B den gleichen Wert haben
                     bitmap.SetPixel(x, y,
                                     Color.FromArgb(c.A, grauwert, grauwert, grauwert));
                  }
               }

               // Speichern (Leider kann man nicht in Bilddateien speichern, die in eine 
               //            Image-Komponente geladen wurden. Daher muss eine Kopie erstellt,
               //            die Image-Bilder freigegeben, dann gespeichert und anschlieend die
               //            Kopie in das Image geladen werden.)
               Bitmap copy = new Bitmap(bild);
               bild.Dispose();
               pbBild.Image.Dispose();
               copy.Save(bilddateien[index]);


               pbBild.Image = copy;
            }
         }
      }

      // Hier steht der Code der ausgefhrt wird, wenn der BackgroundWorker fertig ist
      // In unserem Fall wird der Cursor zurckgesetzt.
      private void backgroundWorker1_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e)
      {
         this.UseWaitCursor = false;
      }
   }
}