﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Rechentrainer
{
   public partial class Form1 : Form
   {
      private Random gen;
      private int wert1;
      private int wert2;
      private int indexOp;

      String[] opzeichen;

      public Form1()
      {
         InitializeComponent();

         // Array mit zulässigen Operatoren
         opzeichen = new String[] { "+", "-", "*", "/" };

         // Zufallsgenerator 
         gen = new Random();


         // Start-Aufgabe stellen
         neueAufgabe();
      }


      private void btn_Berechnen_Click(object sender, EventArgs e)
      {
         // Lösung des Anwenders einlesen
         double ergebnisAnwender;

         try
         {
            ergebnisAnwender = Convert.ToDouble(tb_Ergebnis.Text);
         }
         catch (Exception ex)
         {
            MessageBox.Show("Sie haben kein gültiges Ergebnis eingegeben",
                            "Bedienungsfehler");

            // Abbrechen
            return;
         }

         // Lösung berechnen
         double loesung = loesungBerechnen();

         // Ergebnis des Anwenders auswerten
         if (loesung == ergebnisAnwender)
         {
            MessageBox.Show("Korrekt!", "Glückwunsch");
         }
         else
         {
            MessageBox.Show("Leider falsch. Das korrekte Ergebnis wäre " +
                            loesung.ToString("F") +
                            " gewesen. Versuchen Sie es noch einmal.",
                            "Sorry");
         }

         // Ergebnisfeld leeren und neue Aufgabe stellen
         tb_Ergebnis.Text = "";
         neueAufgabe();
      }


      private void neueAufgabe()
      {
         wert1 = gen.Next(100);
         wert2 = gen.Next(100);
         indexOp = gen.Next(4);
         lb_Wert1.Text = wert1.ToString();
         lb_Wert2.Text = wert2.ToString();
         lb_operator.Text = opzeichen[indexOp];
      }

      private double loesungBerechnen()
      {
         double loesung = 0.0;

         if (lb_operator.Text == "+")
         {
            loesung = wert1 + wert2;
         }
         else if (lb_operator.Text == "-")
         {
            loesung = wert1 - wert2;
         }
         else if (lb_operator.Text == "*")
         {
            loesung = wert1 * wert2;
         }
         else if (lb_operator.Text == "/")
         {
            loesung = wert1 / wert2;
         }

         return loesung;
      }

   }
}
